﻿Imports System.ComponentModel
Imports System.IO.Ports
Imports YMLib

Public Class frmMain_SER_REL_32

    Private WithEvents YMCom As New YMRS232
    Dim SendeByte1, SendeByte2, SendeByte3, SendeByte4 As String
    Dim OUTPUT1, OUTPUT2, OUTPUT3, OUTPUT4 As Int32
    Dim Parse1, Parse2, Parse3, Parse4 As String


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim port As String

        cmbCOM_PORT.Items.Clear()

        For Each port In YMCom.YM_COM_Ports
            cmbCOM_PORT.Items.Add(port)
        Next port

        cmbSek.SelectedIndex = 0
        cmbCOM_PORT.SelectedIndex = 0
        cmbBaudRate.SelectedIndex = 0
    End Sub


#Region "User Action"
    Private Sub Checkbox1_Click(sender As Object, e As EventArgs) Handles CheckBox8.Click, CheckBox7.Click, CheckBox6.Click, CheckBox5.Click, CheckBox4.Click, CheckBox3.Click, CheckBox2.Click, Checkbox1.Click

        Dim myCheckBoxRelKanal As CheckBox = DirectCast(sender, CheckBox)

        If myCheckBoxRelKanal.CheckState = 1 Then
            SendeByte1 += CInt(myCheckBoxRelKanal.Tag)
        Else
            SendeByte1 -= CInt(myCheckBoxRelKanal.Tag)
        End If
        SchaltZustandSenden()
    End Sub

    Private Sub CheckBox16_Click(sender As Object, e As EventArgs) Handles CheckBox9.Click, CheckBox16.Click, CheckBox15.Click, CheckBox14.Click, CheckBox13.Click, CheckBox12.Click, CheckBox11.Click, CheckBox10.Click

        Dim myCheckBoxRelKanal As CheckBox = DirectCast(sender, CheckBox)

        If myCheckBoxRelKanal.CheckState = 1 Then

            SendeByte2 += CInt(myCheckBoxRelKanal.Tag)
        Else
            SendeByte2 -= CInt(myCheckBoxRelKanal.Tag)

        End If
        SchaltZustandSenden()
    End Sub

    Private Sub CheckBox17_Click(sender As Object, e As EventArgs) Handles CheckBox24.Click, CheckBox23.Click, CheckBox22.Click, CheckBox21.Click, CheckBox20.Click, CheckBox19.Click, CheckBox18.Click, CheckBox17.Click

        Dim myCheckBoxRelKanal As CheckBox = DirectCast(sender, CheckBox)

        If myCheckBoxRelKanal.CheckState = 1 Then

            SendeByte3 += CInt(myCheckBoxRelKanal.Tag)
        Else
            SendeByte3 -= CInt(myCheckBoxRelKanal.Tag)

        End If
        SchaltZustandSenden()
    End Sub



    Private Sub CheckBox25_Click(sender As Object, e As EventArgs) Handles CheckBox32.Click, CheckBox31.Click, CheckBox30.Click, CheckBox29.Click, CheckBox28.Click, CheckBox27.Click, CheckBox26.Click, CheckBox25.Click

        Dim myCheckBoxRelKanal As CheckBox = DirectCast(sender, CheckBox)

        If myCheckBoxRelKanal.CheckState = 1 Then

            SendeByte4 += CInt(myCheckBoxRelKanal.Tag)
        Else
            SendeByte4 -= CInt(myCheckBoxRelKanal.Tag)

        End If
        SchaltZustandSenden()
    End Sub




    Private Sub btnAllOFF_Click(sender As Object, e As EventArgs) Handles btnAllOFF.Click
        SendeByte1 = 0
        SendeByte2 = 0
        SendeByte3 = 0
        SendeByte4 = 0


        SchaltZustandSenden()
    End Sub
    Private Sub btnAllON_Click(sender As Object, e As EventArgs) Handles btnAllON.Click
        SendeByte1 = 255
        SendeByte2 = 255
        SendeByte3 = 255
        SendeByte4 = 255


        SchaltZustandSenden()
    End Sub
#Region "Kanäle für den Timeout definieren"
    Private Sub btnAll_Channel_ON_Click(sender As Object, e As EventArgs) Handles btnAll_Channel_ON.Click
        For i As Integer = 0 To 7
            myChannel(i).Text = "255"
        Next
    End Sub
    Private Sub btnAll_Channel_OFF_Click(sender As Object, e As EventArgs) Handles btnAll_Channel_OFF.Click
        For i As Integer = 0 To 7
            myChannel(i).Text = "0"
        Next
    End Sub
#End Region

    Private Sub SchaltZustandSenden()
        If YMCom.Is_Port_Open Then
            YMCom.SEND_STATUS_32(SendeByte1, SendeByte2, SendeByte3, SendeByte4)
        End If
    End Sub

    Private Sub btnResetTimeout_Click(sender As Object, e As EventArgs) Handles btnResetTimeout.Click
        YMCom.HW_RESET()
    End Sub
    Private Sub btnOPEN_Port_Click(sender As Object, e As EventArgs) Handles btnConnect.Click

        If YMCom.Is_Port_Open = False Then
            If YMCom.Connect(cmbCOM_PORT.Text, cmbBaudRate.Text) = True Then
                btnConnect.Enabled = False
                btnDisconnect.Enabled = True
                chkTimeOut.Enabled = True
                cmbSek.Enabled = True
                lblSockStat.Text = "Port is open"
            Else
                lblSockStat.Text = "Port is closed"
            End If
        End If
    End Sub
    Private Sub btnCLOSE_Port_Click(sender As Object, e As EventArgs) Handles btnDisconnect.Click

        If YMCom.Is_Port_Open = True Then
            If YMCom.Close_RS232_Port() Then
                YMCom_Disconnected()
            End If
        End If
    End Sub
    Private Sub AboutBox_Click(sender As Object, e As EventArgs) Handles AboutBox.Click
        YMCom.CALL_ABOUT_BOX()
    End Sub
#End Region

    Private Sub Received_Data_From_RS232() Handles YMCom.Connected
        Try

            Invoke(Sub() txtrcv.Text = YMCom.YM_Con_DeviceName)
            Invoke(Sub() lbSN.Text = YMCom.YM_SerialNR)


            Invoke(Sub() Label24.Text = YMCom.YM_TimeoutStatus)

            If YMCom.YM_TimeOutTriggered = 1 Then
                Invoke(Sub() btnResetTimeout.Enabled = True)
                Invoke(Sub() Label24.ForeColor = Color.DarkRed)
            Else
                Invoke(Sub() Label24.ForeColor = Color.Black)
            End If

            If YMCom.YM_OUTPUT1 = 0 Then OUTPUT1 = 0
            If YMCom.YM_OUTPUT2 = 0 Then OUTPUT2 = 0
            If YMCom.YM_OUTPUT3 = 0 Then OUTPUT3 = 0
            If YMCom.YM_OUTPUT4 = 0 Then OUTPUT4 = 0


            Parse1 = YMCom.YM_Parse1
            Parse2 = YMCom.YM_Parse2
            Parse3 = YMCom.YM_Parse3
            Parse4 = YMCom.YM_Parse4




            Invoke(Sub() RelaisAbfragen())

            Invoke(Sub() cmbSek.SelectedIndex = YMCom.YM_SecIndex)
            Invoke(Sub() chkTimeOut.Checked = YMCom.YM_TimeOutChecked)

        Catch ex As Exception

        End Try
    End Sub

    Private Sub RelaisAbfragen()
        Dim i As Integer

        Integer.TryParse(Parse1, OUTPUT1)
        Integer.TryParse(Parse2, OUTPUT2)
        Integer.TryParse(Parse3, OUTPUT3)
        Integer.TryParse(Parse4, OUTPUT4)


        If OUTPUT1 < 0 OrElse OUTPUT1 > 255 Then Return

        'Je nach abgefragene Wert werden die CheckBoxen auf TRUE bzw. auf FALSE gesetzt. 
        For i = 0 To 7
            myCheckBoxen1(i).Checked = (OUTPUT1 And 1 << i) > 0
            myCheckBoxen2(i).Checked = (OUTPUT2 And 1 << i) > 0
            myCheckBoxen3(i).Checked = (OUTPUT3 And 1 << i) > 0
            myCheckBoxen4(i).Checked = (OUTPUT4 And 1 << i) > 0
        Next i

        'Die aktuelle Werte der Zustand werden auch in die Variablen übergeben
        SendeByte1 = OUTPUT1
        SendeByte2 = OUTPUT2
        SendeByte3 = OUTPUT3
        SendeByte4 = OUTPUT4

    End Sub

#Region "TimeOut aktivieren und deaktivieren"
    Private Sub chkTimeOut_CheckedChanged(sender As Object, e As EventArgs) Handles chkTimeOut.CheckedChanged
        If YMCom.Is_Port_Open Then

            If YMCom.YM_TimeOutTriggered = 1 Then
                chkTimeOut.Checked = False
            End If

            If YMCom.YM_TimeOutTriggered = 0 Then
                If chkTimeOut.Checked Then
                    cmbSek.Enabled = False
                    btnResetTimeout.Enabled = False
                    GroupBox4.Enabled = False

                    'TimeOut wird aktiviert, der Interval wird festgelegt und die Kanäle werden definiert, welches beim TIMEOUT Auslösung 
                    'eingeschaltet bzw. ausgeschaltet werden sollen. 
                    'Die Zeiten von 5s bis 53s werden durch den Index der ComboBox von 0-48 festgelegt.

                    YMCom.TIMEOUT_INTERVAL_AND_CHANNEL_32(CByte(cmbSek.SelectedIndex), CByte(txtch1.Text), CByte(txtch2.Text), CByte(txtch3.Text), CByte(txtch4.Text))



                ElseIf Not chkTimeOut.Checked Then
                    'TimeOut wird deaktiviert
                    YMCom.TIMEOUT_DISABLE()

                    cmbSek.Enabled = True
                    btnResetTimeout.Enabled = True
                    GroupBox4.Enabled = True



                End If
            End If

        End If
    End Sub
#End Region
    Private Sub YMCom_Disconnected() Handles YMCom.Disconnected

        If InvokeRequired Then
            Invoke(Sub() txtrcv.Text = "No device connected")
            Invoke(Sub() lblSockStat.Text = "Port is closed")
            Invoke(Sub() Label24.Text = "")
            Invoke(Sub() btnConnect.Enabled = True)
            Invoke(Sub() btnDisconnect.Enabled = False)
            Invoke(Sub() chkTimeOut.Enabled = False)
            Invoke(Sub() cmbSek.Enabled = False)
            Invoke(Sub() AllCheckBoxEmpty())

        Else
            txtrcv.Text = "No device connected"
            lblSockStat.Text = "Port is closed"
            Label24.Text = ""
            btnConnect.Enabled = True
            btnDisconnect.Enabled = False
            chkTimeOut.Enabled = False
            cmbSek.Enabled = False
            AllCheckBoxEmpty()


        End If

    End Sub

#Region "CheckBoxen deaktivieren"
    Private Sub AllCheckBoxEmpty()
        Dim i As Integer
        For i = 0 To 7
            myCheckBoxen1(i).Checked = False
            myCheckBoxen2(i).Checked = False
            myCheckBoxen3(i).Checked = False
            myCheckBoxen4(i).Checked = False
        Next
    End Sub


#End Region


End Class
